<!--
 * Copyright 2011 IHE International (http://www.ihe.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 -->
<ui:composition
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns="http://www.w3.org/1999/xhtml">

    <ui:decorate template="#{form_template == null ? '/layout/form/_form_field_tm_criteria_4-5.xhtml' : form_template}">
        <ui:param name="id" value="#{filterId}Panel"/>
        <ui:define name="label">
            <h:outputText value="#{filterName}"/>

            <a4j:jsFunction name="updateField">
                <a4j:param name="param1" assignTo="#{filter.updatedField}"/>
            </a4j:jsFunction>

            <a4j:jsFunction name="refresh" render="#{filterForm}"
                            execute="#{filterId}Field1,#{filterId}Field2,#{filterForm}"/>
        </ui:define>

        <s:span id="#{filterId}Panel" styleClass="gzl-never-wrap form-inline">
            <h:selectOneMenu styleClass="form-control"
                             value="#{filter.filterValues[filterId].intervalType}"
                             onchange="updateField('#{filterId}');">
                <f:selectItems value="#{filter.intervalTypes}"/>
                <a4j:ajax event="change" execute="@this" render="#{filterForm}"/>
            </h:selectOneMenu>
            <s:span id="#{filterId}Fields">
                <h:panelGroup rendered="#{filter.filterValues[filterId].firstValue}">

                    <div class="input-group">

                        <div class="input-group-addon"><span class="gzl-icon-calendar"/></div>

                        <h:inputText id="#{filterId}Field1" styleClass="gzl-date-input#{filterId} form-control"
                                     value="#{filter.filterValues[filterId].value1}">
                            <f:convertDateTime pattern="#{filter.criterions[filterId].useTime ? 'yyyy-MM-dd\'T\'HH:mm:ssXXX' : 'yyyy-MM-dd'}"/>
                        </h:inputText>

                    </div>

                    <script>
                        var datePickerOptions = {};
                        datePickerOptions.minDate = '01/01/1990';
                        datePickerOptions.showDropdowns = true;
                    </script>

                    <h:panelGroup rendered="#{not filter.criterions[filterId].useTime}">
                        <script>
                            datePickerOptions.locale = {
                                format: 'YYYY-MM-DD'
                            };
                        </script>
                    </h:panelGroup>
                    <h:panelGroup rendered="#{filter.criterions[filterId].useTime}">
                        <script>
                            datePickerOptions.locale = {
                                format: ''
                            };
                            datePickerOptions.timePicker = true;
                            datePickerOptions.timePickerIncrement = 10;
                        </script>
                    </h:panelGroup>

                    <h:panelGroup rendered="#{not filter.filterValues[filterId].dualValue}">
                        <script>
                            datePickerOptions.singleDatePicker = true;
                        </script>
                    </h:panelGroup>
                    <h:panelGroup rendered="#{filter.filterValues[filterId].dualValue}">

                        <h:inputHidden id="#{filterId}Field2" value="#{filter.filterValues[filterId].value2}">
                            <f:convertDateTime pattern="#{filter.criterions[filterId].useTime ? 'yyyy-MM-dd\'T\'HH:mm:ssXXX' : 'yyyy-MM-dd'}"/>
                        </h:inputHidden>

                        <!--@formatter:off-->
                        <script>
                            datePickerOptions.linkedCalendars = false;
                            datePickerOptions.locale = {
                                applyLabel: #{messages['gazelle.common.Apply']},
                                cancelLabel: #{messages['gazelle.common.Cancel']},
                                weekLabel: #{messages['gazelle.common.W']},
                                customRangeLabel: #{messages['gazelle.common.CustomRange']},
                            };
                            datePickerOptions.ranges = {
                                #{messages['gazelle.common.Today']}: [moment(), moment()],
                                #{messages['gazelle.common.Yesterday']}: [moment().subtract(1, "days"), moment().subtract(1, "days")],
                                #{messages['gazelle.common.Last7']}: [moment().subtract(6, "days"), moment()],
                                #{messages['gazelle.common.Last30']}: [moment().subtract(29, "days"), moment()],
                                #{messages['gazelle.common.ThisMonth']}: [moment().startOf("month"), moment().endOf("month")],
                                #{messages['gazelle.common.LastMonth']}: [moment().subtract(1, "month").startOf("month"), moment().subtract(1, "month").endOf("month")],
                                #{messages['gazelle.common.ThisYear']}: [moment().startOf("year"), moment()],
                                #{messages['gazelle.common.LastYear']}: [moment().subtract(1, "year").startOf("year"), moment().subtract(1, "year").endOf("year")],
                            };
                            datePickerOptions.startDate = moment(#{filter.filterValues[filterId].value1.getTime()}).locale('#{localeSelector.localeString}');
                            datePickerOptions.endDate = moment(#{filter.filterValues[filterId].value2.getTime()}).locale('#{localeSelector.localeString}');
                        </script>
                        <!--@formatter:on-->
                    </h:panelGroup>

                    <script>
                        jq162(document).ready(function () {
                            moment.locale('#{localeSelector.localeString}');
                            jq162('input.gzl-date-input#{filterId}').daterangepicker(datePickerOptions);

                            jq162('input.gzl-date-input#{filterId}').on('apply.daterangepicker', function (ev, picker) {
                                jq162('input[id*=#{filterId}Field1]').val(picker.startDate.locale('#{localeSelector.localeString}').format(datePickerOptions.locale.format));
                                jq162('input[id*=#{filterId}Field2]').val(picker.endDate.locale('#{localeSelector.localeString}').format(datePickerOptions.locale.format));
                                refresh();
                            });
                        });
                    </script>

                </h:panelGroup>
                <a4j:commandLink event="click"
                                 actionListener="#{filter.resetDateField(filterId)}"
                                 render="#{filterForm}" execute="#{filterId}Field1,#{filterId}Field2,#{filterForm}">
                    <span class="gzl-icon-times"/>
                </a4j:commandLink>
            </s:span>
        </s:span>
    </ui:decorate>
</ui:composition>
